

/**
 * Step 1 action back in history
 */
function bubbletimer_history_backward() {
  if (bubbletimer_history_backward_array.length == 0) return;
  
  var oImages = _bubbletimer_get_history();
  _bubbletimer_save_forward(oImages);
  if (oImages.length > 1) {
    for (var idx in oImages) {
      _bubbletimer_slot_select.apply(oImages[idx], [BUBBLETIMER_SLOT_DEFAULT_SELECT, BUBBLETIMER_NO_HISTORY_SAVE]);
    }
  } else {
    _bubbletimer_slot_select.apply(oImages, [BUBBLETIMER_SLOT_DEFAULT_SELECT, BUBBLETIMER_NO_HISTORY_SAVE]);
  }
}


/**
 * Step 1 action forward in history
 */
function bubbletimer_history_forward() {
  if (bubbletimer_history_forward_array.length == 0) return;
  
  var oImages = _bubbletimer_get_forward();
  bubbletimer_history_backward_array.push(oImages);
  if (oImages.length > 1) {
    for (var idx in oImages) {
      _bubbletimer_slot_select.apply(oImages[idx], [BUBBLETIMER_SLOT_DEFAULT_SELECT, BUBBLETIMER_NO_HISTORY_SAVE]);
    }
  } else {
    _bubbletimer_slot_select.apply(oImages, [BUBBLETIMER_SLOT_DEFAULT_SELECT, BUBBLETIMER_NO_HISTORY_SAVE]);
  }
}

/**
 * Save a slot to the history
 * @param object history
 */
function _bubbletimer_save_history(history) {
  bubbletimer_history_backward_array.push(history);
  // If a new slot marked/unmarked, the redo history (future) has to be erased
  bubbletimer_history_forward_array = [];
}


/**
 * Get the latest action from history (past)
 * 
 * @return object
 */
function _bubbletimer_get_history() {
  return bubbletimer_history_backward_array.pop();
}


/**
 * Save a slot to into the redo (future) array
 * 
 * @param object history
 */
function _bubbletimer_save_forward(history) {
  bubbletimer_history_forward_array.push(history);
}


/**
 * Get an already undo-d action from the redo (future) array
 * @return object
 */
function _bubbletimer_get_forward() {
  return bubbletimer_history_forward_array.pop();
}